<template>
    <div class="page">
        <div class="card">
            <div class="card-header">
                <h3>List Blog</h3>
            </div>
            <table class="table table-striped table-sm card-body">
                <thead>
                    <tr>
                        <th>ID</th>
                        <th>Tin</th>
                        <th>Loại</th>
                        <th>Trạng thái</th>
                        <th>Vị trí</th>
                        <th>Ngày public</th>
                        <th>Edit</th>
                        <th>Delete</th>
                    </tr>
                </thead>
                <tbody>
                    <tr v-for="(item,idx) in itemTable" :key="idx">
                        <td>{{item.id}}</td>
                        <td>{{item.title}}</td>
                        <td>{{ convertCategory(item.category) }}</td>
                        <td>{{ convertStatus(item.public) }}</td>
                        <td>{{ getListPositionName(item.position) }}</td>
                        <td>{{item.data_pubblic}}</td>
                        <td><nuxt-link  :to="linkEdit(item.id)"><button type="button" class="btn btn-outline-primary">Edit</button></nuxt-link></td>   
                        <td><button type="button" v-on:click="deleteBlog(item.id)" class="btn btn-outline-danger">Delete</button></td>
                    </tr>
                </tbody>
            </table>
        </div>
    </div>
</template>

<script>
import {CATEGORIES, POSITIONS, BASE_API} from '../constant/constantSystem.js';

export default {
    props: {
        posts:{
            type: Array,
        },
        itemTable: {
            type: Array
        },
    },
    data: function(){
        return {
            itemTables: [],
        };
    },

    computed: {
        CATEGORIES: CATEGORIES,
        POSITIONS: POSITIONS,
        BASE_API: BASE_API,
    },

    methods:{
        async deleteBlog(id) {
            alert('Bạn chắc chắn muốn xóa ???')
            if(id) {
                var deletePost = await this.$axios.$delete('http://localhost:3000/blogs/'+ id);
                location.reload()
            }
        },

        convertStatus(status) {
            if (status) {
                return "Yes";
            }
            return "No";
        },

        linkEdit(id) {
            return "/blog/" + id;
        },

        convertCategory(categoryId) {
            var category = CATEGORIES.find((cate) => cate.id == categoryId);
            if (category) {
                return category.name;
            }
            return "";
        },

         getListPositionName(positionIds) {
            return POSITIONS.filter(blogList => positionIds.includes(blogList.id))
                .map(blogList => blogList.name)
                .join(', ')
        },

    },
}
</script>
<style>
    table {
        text-align: center;
        width: 100%;
    }
    .page {
        padding-top:3vh;
        padding-bottom: 5vh;
    }

</style>